"""__init__.py"""

import sys
from typing import TYPE_CHECKING

from lazy_imports import LazyImporter


if TYPE_CHECKING:
    from ._5525 import AbstractMeasuredDynamicResponseAtTime
    from ._5526 import DynamicForceResultAtTime
    from ._5527 import DynamicForceVector3DResult
    from ._5528 import DynamicTorqueResultAtTime
    from ._5529 import DynamicTorqueVector3DResult
else:
    import_structure = {
        "_5525": ["AbstractMeasuredDynamicResponseAtTime"],
        "_5526": ["DynamicForceResultAtTime"],
        "_5527": ["DynamicForceVector3DResult"],
        "_5528": ["DynamicTorqueResultAtTime"],
        "_5529": ["DynamicTorqueVector3DResult"],
    }

    sys.modules[__name__] = LazyImporter(
        __name__,
        globals()["__file__"],
        import_structure,
    )

__all__ = (
    "AbstractMeasuredDynamicResponseAtTime",
    "DynamicForceResultAtTime",
    "DynamicForceVector3DResult",
    "DynamicTorqueResultAtTime",
    "DynamicTorqueVector3DResult",
)
